package Package1;


import java.io.File;
import java.io.IOException;
import javax.xml.parsers.DocumentBuilder;
import javax.xml.parsers.DocumentBuilderFactory;
import javax.xml.parsers.ParserConfigurationException;
import javax.xml.transform.OutputKeys;
import javax.xml.transform.Result;
import javax.xml.transform.Source;
import javax.xml.transform.Transformer;
import javax.xml.transform.TransformerException;
import javax.xml.transform.TransformerFactory;
import javax.xml.transform.dom.DOMSource;
import javax.xml.transform.stream.StreamResult;
import org.w3c.dom.*;
import org.xml.sax.SAXException;

public class CreateNodes {

    public static void main(String[] args) {
        DocumentBuilderFactory factory = DocumentBuilderFactory.newInstance();
        try {
            // Apertura e parsing del file
            DocumentBuilder builder = factory.newDocumentBuilder();
            File file = new File("prova.xml");
            Document doc = builder.parse(file);
            Element root = doc.getDocumentElement();
            System.out.println("Il nodo radice e': " + root.getNodeName());

            // Creazione di un nuovo elemento
            Element e = doc.createElement("titolo");
            // Aggiunta di testo all'elemento
            e.setTextContent("Volare");
            // Aggiunta di attributi all'elemento
            e.setAttribute("lingua", "eng");
            // Aggiunta dell'elemento alla radice
            root.appendChild(e);

            // Commenti
            Comment c = doc.createComment("Questo e' un commento");
            root.appendChild(c);
            System.out.println("Il nodo commento e' preceduto da: " + c.getPreviousSibling().getNodeName());

            // Variazione del valore di un attributo
            Attr a = e.getAttributeNode("lingua");
            a.setValue("ita");
            // Alternativa:
            e.setAttribute("lingua", "ita");
            
            // Salvataggio
            try {
                Result output = new StreamResult(new File("nuova_prova.xml"));
                Source input = new DOMSource(doc);

                TransformerFactory tf = TransformerFactory.newInstance();
                Transformer t = tf.newTransformer();
                t.setOutputProperty(OutputKeys.INDENT, "yes");
                t.setOutputProperty("{http://xml.apache.org/xslt}indent-amount", "3");

                t.transform(input, output);
            } catch (TransformerException ex) {
            }
        } catch (ParserConfigurationException | SAXException | IOException e) {
            System.out.println("Errore nell'elaborazione del file");
            System.exit(1);
        }

    }
}
