package Package1;


import java.io.File;
import java.io.IOException;
import javax.xml.parsers.DocumentBuilder;
import javax.xml.parsers.DocumentBuilderFactory;
import javax.xml.parsers.ParserConfigurationException;
import org.w3c.dom.Document;
import org.w3c.dom.Element;
import org.w3c.dom.NodeList;
import org.xml.sax.SAXException;

public class DOMParentChildrenSiblings {

    public static void main(String[] args) {
        DocumentBuilderFactory factory = DocumentBuilderFactory.newInstance();
        factory.setValidating(true);
        factory.setIgnoringElementContentWhitespace(true);
        try {
            DocumentBuilder builder = factory.newDocumentBuilder();
            File file = new File("gounod_ave_maria.xml");
            Document doc = builder.parse(file);

            NodeList nl = doc.getElementsByTagName("notational");
            // Attenzione: nel codice seguente non vengono gestite le condizioni di errore, dando per scontato che il file sia come ci aspettiamo
            Element e = (Element) nl.item(0);

            Element parent = (Element) e.getParentNode();
            System.out.println("Genitore: " + parent.getNodeName());

            Element firstChild = (Element) e.getFirstChild();
            System.out.println("Primo figlio: " + firstChild.getNodeName());

            NodeList children = e.getChildNodes();
            System.out.println("L'elemento corrente ha " + children.getLength() + " nodi figli");

            Element prevSibling = (Element) e.getPreviousSibling();
            System.out.println("Nodo fratello che precede: " + prevSibling.getNodeName());

            Element nextSibling = (Element) e.getNextSibling();
            System.out.println("Nodo fratello che segue: " + nextSibling.getNodeName());

            Element nextNextSibling = (Element) nextSibling.getNextSibling();
            if (nextNextSibling != null) {
                System.out.println("Altro fratello che segue: " + nextNextSibling.getNodeName()); // genera errore se richiamato su un puntatore nullo
            } else {
                System.out.println("Non esiste un nodo successivo");
            }

        } catch (ParserConfigurationException | SAXException | IOException e) {
            System.out.println("Errore nell'elaborazione del file");
            System.exit(1);
        }

    }

}
