package Package1;

public class Helmholtz {

    public static void main(String[] args) {
        if (args.length != 2) {
            System.out.println("Numero di argomenti errato, uso: Helmholtz nota ottava");
            System.exit(1);
        }
        String p = args[0].toLowerCase();
        if (!p.equals("c") && !p.equals("d") && !p.equals("e") && !p.equals("f")
                && !p.equals("g") && !p.equals("a") && !p.equals("b")) {
            System.out.println("Nome della nota errato (" + p 
                    + "). La nota deve essere espressa in notazione anglosassone");
            System.exit(1);
        }
        int octave = 0;
        try {
            octave = Integer.parseInt(args[1]);
        } catch (NumberFormatException e) {
            System.out.println("Numero dell'ottava errato (" + p + ")");
            System.exit(1);
        }
        String result = "La nota " + args[0] + args[1] 
                + " convertita in codice di Helmholtz risulta ";
        if (octave >= 3) {
            result += p;
            for (int i = 3; i < octave; i++)
                result += "'";
        } else {
            result += p.toUpperCase();
            for (int i = 1; i >= octave; i--)
                result += ",";
        }
        System.out.println(result);
    }
}
