package Package2;

enum BritishNoteValue {
    SEMIBREVE, MINIM, CROTCHET, QUAVER, SEMIQUAVER, DEMISEMIQUAVER, HEMIDEMISEMIQUAVER, SEMIHEMIDEMISEMIQUAVER, DEMISEMIHEMIDEMISEMIQUAVER
}

enum AmericanNoteValue {
    WHOLE, HALF, QUARTER, EIGHTH, SIXTEENTH, THIRTYSECOND, SIXTYFOURTH, HUNDREDTWENTYEIGHTH, TWOHUNDREDFIFTYSIXTH
}

class MusicFraction {

    private int numerator;
    private int denominator;

    public MusicFraction() {
        numerator = 1;
        denominator = 1;
    }

    public MusicFraction(int n, int expd) {
        numerator = Math.abs(n);
        expd = Math.max(1, expd);
        expd = Math.min(expd, 8);
        denominator = (int) (Math.pow(2, expd)); // pow restituisce un double
    }

    public MusicFraction(int expd) {
        numerator = 1;
        expd = Math.max(1, expd);
        expd = Math.min(expd, 8);
        denominator = (int) (Math.pow(2, expd));
    }

    public MusicFraction(BritishNoteValue value) {
        numerator = 1;
        denominator = (int) (Math.pow(2, value.ordinal()));
    }

    public MusicFraction(AmericanNoteValue value) {
        numerator = 1;
        denominator = (int) (Math.pow(2, value.ordinal()));
    }

    @Override
    public String toString() {
        return (numerator + "/" + denominator);
    }

    public static void main(String[] argv) {

        // test dei costruttori
        MusicFraction f0 = new MusicFraction();
        MusicFraction f1 = new MusicFraction(3);
        MusicFraction f2 = new MusicFraction(1, 4);
        MusicFraction f3 = new MusicFraction(1, 16); // supera il valore massimo consentito
        MusicFraction f4 = new MusicFraction(BritishNoteValue.CROTCHET);

        System.out.println("Test:");
        System.out.println("The fraction f0 is " + f0);
        System.out.println("The fraction f1 is " + f1);
        System.out.println("The fraction f2 is " + f2);
        System.out.println("The fraction f3 is " + f3);
        System.out.println("The fraction f4 is " + f4);
    }
}
